#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <Windows.h>

HANDLE createPipeHandle(const char* name)
{
	HANDLE pipeHandle = CreateFile(name, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (pipeHandle == INVALID_HANDLE_VALUE)
	{
		printf("Cannot open pipe! %ld\n", GetLastError());
		return pipeHandle;
	}

	return pipeHandle;
}

int main()
{
	char pipeName[100];
	printf("Enter pipe name: ");
	scanf("%s", pipeName);

	HANDLE pipeHandle = createPipeHandle(pipeName);
	if (pipeHandle == INVALID_HANDLE_VALUE)
	{
		return -1;
	}

	printf("Client connected\n");

	char recvBuffer[256], sendBuffer[256];
	do
	{
		fgets(sendBuffer, 256, stdin);
		sendBuffer[strlen(sendBuffer) - 1] = '\0';

		if (strlen(sendBuffer) > 0)
		{
			unsigned long bytesWritten;
			WriteFile(pipeHandle, sendBuffer, strlen(sendBuffer) + 1, &bytesWritten, 0);
			printf("Number of bytes sent: %ld\n", bytesWritten);

			unsigned long bytesRead;
			ReadFile(pipeHandle, recvBuffer, 256, &bytesRead, 0);
			if (bytesRead > 0)
			{
				printf("Received message: %s\n", recvBuffer);
			}
		}
	} while (strcmp(sendBuffer, "x") != 0);

	CloseHandle(pipeHandle);

	return 0;
}
