#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <Windows.h>

HANDLE createPipeHandle(const char* name)
{
	HANDLE pipeHandle = CreateNamedPipe(name, PIPE_ACCESS_DUPLEX, PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE | PIPE_WAIT, 1, 1024, 1024, NMPWAIT_USE_DEFAULT_WAIT, NULL);
	if (pipeHandle == INVALID_HANDLE_VALUE)
	{
		printf("Cannot open pipe! %ld\n", GetLastError());
		return pipeHandle;
	}

	return pipeHandle;
}


int main()
{
	char pipeName[100];
	printf("Enter pipe name: ");
	scanf("%s", pipeName);

	HANDLE pipeHandle = createPipeHandle(pipeName);
	if (pipeHandle == INVALID_HANDLE_VALUE)
	{
		return -1;
	}

	if (ConnectNamedPipe(pipeHandle, NULL) == FALSE)
	{
		return -1;
	}

	printf("Client connected\n");

	char recvBuffer[256], sendBuffer[256];
	do
	{
		unsigned long bytesRead;
		ReadFile(pipeHandle, recvBuffer, 256, &bytesRead, 0);
		if (bytesRead > 0)
		{
			printf("Received message: %s\n", recvBuffer);
			unsigned long bytesWritten;

			for (size_t i = 0; i <= strlen(recvBuffer); i++)
			{
				sendBuffer[i] = toupper(recvBuffer[i]);
			}
			
			WriteFile(pipeHandle, sendBuffer, strlen(sendBuffer) + 1, &bytesWritten, 0);
			printf("Number of bytes sent: %ld\n", bytesWritten);
		}

	} while (strcmp(recvBuffer, "x") != 0);

	DisconnectNamedPipe(pipeHandle);

	return 0;
}
